#ifndef SOFT_TIMER_H_
#define SOFT_TIMER_H_

#define MAX_NUMBERS_OF_TIMERS	8
#define reset_flag(x)			task_flags &= ~(1 << x)

volatile unsigned char i;

volatile static struct
{
	unsigned char number;			//     
	unsigned int time;				//   
}
soft_timer[MAX_NUMBERS_OF_TIMERS];

void set_task(unsigned char new_number, unsigned int new_time)
{
	cli();
	
	for (i = 0; i != MAX_NUMBERS_OF_TIMERS; i++)   	//   .      
	{
		if (soft_timer[i].number == new_number)		//       
		{
			soft_timer[i].time = new_time;			//   
			sei();
			return;
		}
	}
	
	for (i = 0; i != MAX_NUMBERS_OF_TIMERS; i++)	//   ,    
	{
		if (soft_timer[i].number == 255)
		{
			soft_timer[i].number = new_number;
			soft_timer[i].time   = new_time;
			sei();
			return;
		}
	}
	sei();
	//    return c   -   
}

#endif /* SOFT_TIMER_H_ */